// @name "Lyrics (04.09.2013)"
// @author "NADIR1"

var g_need_calc = true,
a_active = false,
g_active = false,
g_timer = null;
var g_textheight = 0,
g_offset = 0,
pW = 0,
pH = 0;
var metadb, fileinfo, g_text, g_nolyrics;

var lyric_font = window.GetProperty("Lyrics.Font", "Segoe UI");
var lyric_f_size = window.GetProperty("Lyrics.Font.Size", 12);
var g_font_headers = gdi.Font(lyric_font, lyric_f_size);
var ext_lyrics = window.GetProperty("Lyrics.Path", fb.FoobarPath + "lyrics\\" + ("%artist% - %title%"));

// ============================================================= // CREATE OPTIONS // =============== //

function get_loader() {
	var a,
	b,
	c;
	a = utils.CheckComponent("foo_lyricsgrabber2", true);
	b = utils.CheckComponent("foo_lyricsdb", true);
	c = a ? "Search all" : "get from db";
	d_command = a || b ? window.GetProperty("Lyrics.Search.Command", c) : window.SetProperty("Lyrics.Search.Command", null);
}

get_loader();

function opt_init() {
	a_scroll = window.GetProperty("Lyrics.Autoscroll.Enable", true);
	a_fader = window.GetProperty("Lyrics.Autoscroll.Fading", true);
}

opt_init();

function pad_init() {
	hPad = window.GetProperty("Lyrics.Padding", 15);
	if (typeof hPad != "number" || hPad < 0)
		hPad = 0;
}

pad_init();

var g_drag = false;
var g_drag_y = 0;

// ============================================================================================== //

function get_text() {
	metadb = fb.GetNowPlaying();
	var a,
	b,
	c,
	d;

	if (metadb) {
		fileinfo = metadb.GetFileInfo();
		a = fileinfo.MetaValue(fileinfo.MetaFind("lyrics"), 0);
		b = fileinfo.MetaValue(fileinfo.MetaFind("unsynced lyrics"), 0);

		// ============================================================= // TITLEFORMATE // ================= //
		var artist_01_tf = fb.TitleFormat("%artist%")
			.Eval();
		var title_01_tf = fb.TitleFormat("%title%")
			.Eval();
		var album_01_tf = fb.TitleFormat("%album%[ - %date%]")
			.Eval();
		var genre_01_tf = fb.TitleFormat("%genre%")
			.Eval();

		var tech_01_tf = fb.TitleFormat("[$caps(%codec%) - ][%bitrate% kbps][ %codec_profile%]")
			.Eval();
		var tech_02_tf = fb.TitleFormat("%samplerate% Hz[ $caps(%channels%)]")
			.Eval();
		var tech_03_tf = fb.TitleFormat("$if($day_of_month(%added%),$day_of_month(%added%).$month(%added%).$year(%added%) - $time(%added%), not in Media Library)")
			.Eval();
		var tech_04_tf = fb.TitleFormat("$if(%play_count%,playcount %play_count%, never played)")
			.Eval();

		//if (isPC) {
		g_nolyrics = "Artist:\n" + (artist_01_tf + "\n") + "\nTitle:\n" + (title_01_tf + "\n") + "\nAlbum:\n" + (album_01_tf + "\n") + "\nGenre:\n" + (genre_01_tf + "\n") + "\nTech:\n" + (tech_01_tf + "\n") + (tech_02_tf + "\n") + ([tech_03_tf + "\n"]) + (tech_04_tf);
		//} else {
		//	g_nolyrics = "Artist:\n" + (artist_01_tf + "\n") + "\nTitle:\n" + (title_01_tf + "\n") + "\nAlbum:\n" + (album_01_tf + "\n") + "\nGenre:\n" + (genre_01_tf + "\n") + "\nTech:\n" + (tech_01_tf + "\n") + (tech_02_tf + "\n") + ([tech_03_tf + "\n"]) + (tech_04_tf);
		//}

		if (c = a ? a : b)
			d = c;
		else {
			var arr = utils.Glob(fb.TitleFormat(ext_lyrics)
					.Eval() + ".*")
				.toArray();
			loop : for (var i = 0; i < arr.length; ++i) {
				if (arr[i].match(/\.lrc$/m)) {
					d = utils.ReadTextFile(arr[i]);
					break loop;
				} else if (arr[i].match(/\.txt$/m)) {
					d = utils.ReadTextFile(arr[i]);
					break loop;
				}
			}
		}

		g_text = d ? d.replace(/\[..:.*?\]/g, "")
			.replace(/^(\r?\n)+/g, "") : g_nolyrics;

	} else {
		g_nolyrics = "TURBO\n Version 1.1\n \n LYRICS PANEL\n \n Lyrics only available\n during playback";
		g_text = g_nolyrics;
	}
}

function calc() {
	var a = gdi.CreateImage(1, 1);
	var b = a.GetGraphics();
	arr = b.GdiDrawText(g_text, g_font_headers, g_textcolor, hPad, 0, pW, pH, 3093)
		.toArray();
	g_textheight = arr[3] - arr[1];
	g_offset = a_active ? wh / 2 : g_textheight > pH ? 0 : (wh - g_textheight) / 2;
	g_need_calc = false;
	a.ReleaseGraphics(b);
	a.Dispose();
	repaintLyrics();
}

function repaintLyrics() {
	window.RepaintRect(0, 0, ww, wh);
}

function applyDelta(delta) {
	var a = g_offset + delta;

	if (a <= 0 && a >= wh - (g_textheight + 20) || a_active) {
		g_offset = a;
		repaintLyrics();
	}
}

function reset() {
	g_need_calc = true;
	g_offset = 0;
	get_text();
}

function CustomMenuLyric(x, y) {
	var a = window.CreatePopupMenu();
	var f = window.CreatePopupMenu();
	var idx;

	a.AppendMenuItem(0, 1, "Refresh");
	a.AppendMenuSeparator();
	a.AppendMenuItem(a_scroll ? 8 : 0, 2, "Auto-scroll");
	a_scroll && a.AppendMenuItem(a_fader ? 8 : 0, 3, "Fading");

	a.AppendMenuSeparator();
	f.AppendTo(a, 0, "Font Size");
	for (var b = 8; b < 16; b++) {
		f.AppendMenuItem(MF_STRING, b, b);
	}
	f.CheckMenuRadioItem(8, 15, lyric_f_size);

	g_active && a.AppendMenuSeparator();
	g_active && a.AppendMenuItem(0, 4, "Online Search");

	if (utils.IsKeyPressed(VK_SHIFT)) {
		a.AppendMenuSeparator();
		a.AppendMenuItem(MF_STRING, 5, "Properties");
		a.AppendMenuItem(MF_STRING, 6, "Configure");
	}

	idx = a.TrackPopupMenu(x, y);

	if (idx != 0)
		switch (true) {
		case (idx == 1):
			reset();
			repaintLyrics();
			break;

		case (idx == 2):
			window.SetProperty("Lyrics.Autoscroll.Enable", a_scroll ? false : true);
			opt_init();
			on_playback_new_track(metadb);
			break;

		case (idx == 3):
			window.SetProperty("Lyrics.Autoscroll.Fading", a_fader ? false : true);
			opt_init();
			break;

		case (idx == 4):
			g_active && fb.RunContextCommand(d_command);
			break;

		case (idx == 5):
			window.ShowProperties();
			break;

		case (idx == 6):
			window.ShowConfigure();
			break;

		case (idx >= 8 && idx <= 15):
			window.SetProperty("Lyrics.Font.Size", lyric_f_size = idx);
			g_font_headers = gdi.Font(lyric_font, lyric_f_size);
			reset();
			break;
		}

	a.Dispose();
	f.Dispose();
}
