﻿//===================================================
//============KG Music Source For ESLyric============
//===============ohyeahyeah 2014-04-06===============
//===================================================

var ado = new ActiveXObject("ADODB.Stream");
var xmlhttp = new ActiveXObject("Msxml2.XMLHTTP.6.0");

function get_my_name()
{
    return "酷狗音乐";
}

function get_version() 
{
    return "0.0.1";
}

function get_author() 
{
    return "ohyeahyeah";
}

function start_search(info,callback)
{
	var artist = KGStringFilter(info.Artist);
	var title = KGStringFilter(info.Title);
    var searchcode = ""
    switch(true){
        case (artist.length == 0):
            searchcode = title;
            break;
        case (artist.length > 0 && title.length > 0):
            searchcode = artist + "-" + title;
            break;
        default:
            break;
    }
    
	try {
		xmlhttp.open("GET","http://lib9.service.kugou.com/websearch/index.php?page=1&cmd=100&keyword=" + encodeURIComponent(searchcode) + "&pagesize=9",false);
		xmlhttp.send();
	} catch (e) {
		return;
	}
    
    var new_lyric = callback.CreateLyric();

	if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
		//parse HTML
		var rex = new RegExp('"singername":"(.*?)","songname":"(.+?)","filename":".+?","hash":"(.+?)"',"g");
		var songid = [];

		for(var i= 0;;i++){
			ret = rex.exec(A2U(xmlhttp.responseBody));
			if(ret == null)break;
	        songid[i] = {
	            hash:ret[3],
	            artist:uz(ret[1]),
	            title:uz(ret[2])
	        };
		}
        //download lyrics
		for(var i=0; i<songid.length;i++){
			url = "http://mobilecdn.kugou.com/new/app/i/krc.php?keyword=" + encodeURIComponent(artist) + "-" + encodeURIComponent(title) + "&timelength=322000&type=1&cmd=200&hash=" + songid[i].hash + "&amp;open2close=-1";
            
            var http_client = utils.CreateHttpRequest("GET");
            var lyric_binstr = http_client.RunEx(url,1);
            if(lyric_binstr.length)
            {
                new_lyric.Title = songid[i].title;
                new_lyric.Artist = songid[i].artist;
                new_lyric.FileType = "krc";
                new_lyric.Source = get_my_name();
                new_lyric.LyricData = lyric_binstr;
                callback.AddLyric(new_lyric);
            }
		}
	}
    new_lyric.Dispose();
}

function KGStringFilter(s){
	s = s.toLowerCase();
	s = s.replace(/\'|·|\&|–/g,"");
	//trim all spaces
	//s = s.replace(/(\s*)|(\s*$)/g,"");
	//truncate all symbols
	s = s.replace(/\(.*?\)|\[.*?]|{.*?}|（.*?/g, "");
	s = s.replace(/[-/:-@[-`{-~]+/g, "");
	//s = et.Translate(s,0x0804,0x02000000);
	s = s.replace(/[\u2014\u2018\u201c\u2026\u3001\u3002\u300a\u300b\u300e\u300f\u3010\u3011\u30fb\uff01\uff08\uff09\uff0c\uff1a\uff1b\uff1f\uff5e\uffe5]+/g, "");
	return s;
}

function A2U(s){
	ado.Type = 1;
	ado.Open();
	ado.Write(s);
	ado.Position = 0;
	ado.Type = 2;
	ado.Charset = "gb2312";
	var ret = ado.ReadText();
	ado.Close();
	return ret;
}

function uz(str){
    var v = str;
	var r = v.match(/\\u[0-9a-fA-F]{4}/g);
	if(r == null) {
		return v;
	}
	for(var i = 0; i < r.length; i++){
		v = v.replace(r[i],unescape(r[i].replace("\\u","%u")));
	}
    return v;
}
