﻿var ado = new ActiveXObject("ADODB.Stream");
var xmlDoc = new ActiveXObject("MSXML.DOMDocument");
var xmlhttp = new ActiveXObject("Msxml2.XMLHTTP.3.0");

var SERVER_URL = "http://ttlrcct2.qianqian.com/dll/lyricsvr.dll?";
var Q_SERVER_URL = "http://qqmusic.qq.com/fcgi-bin/qm_getLyricId.fcg?";
var R_SERVER_URL = "http://music.qq.com/miniportal/static/lyric/";
var QQFilter = " _-*.0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
var $LyricResult = ""

function TTQueryString(artist, title){
	return SERVER_URL+"sh?Artist="+toTTHexQueryString(TTStringFilter(artist))+"&Title="+toTTHexQueryString(TTStringFilter(title))+"&Flags=0";
}

function TTRequestString(index,qr){
	return SERVER_URL+"dl?Id="+qr[index].I+"&Code="+et.CalcTTCode(qr[index].I,toTTHexUTF8(qr[index].A+qr[index].T));
}

function TTQuery(artist, title) {

        try {
		xmlhttp.open("GET", TTQueryString(artist,title), false);
		xmlhttp.send();
        } catch (e) {
		$TTQueryResult = [];
		return;
        }

    if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) {
			AnalyzeTTXML(xmlhttp.responseText);
		} else {
			//et.CreateMessageBox(window.ID ,"Error","Unable to query.",0);
			fb.trace("TTLRX WSHSP_Ver. result::" + (xmlhttp.responsetext || "HTTP error: " + xmlhttp.status));
		}
	}
}

function TTDownload(index) {
	xmlhttp.open("GET", TTRequestString(index,$TTQueryResult), false);
	xmlhttp.send();
    if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) {
            $LyricResult = xmlhttp.responseText;
		} else {
			//et.CreateMessageBox(window.ID ,"Error","Unable to download.",0);
			fb.trace("TTLRX WSHSP_Ver. result::" + (xmlhttp.responsetext || "HTTP error: " + xmlhttp.status));
		}
	}
}

function AnalyzeTTXML(str){
	xmlDoc.loadXML(str);
	var lrc = xmlDoc.getElementsByTagName("lrc");
	$TTQueryResult = [];
    for(var i=0;i<lrc.length;i++){
        $TTQueryResult[i] = {
            I:lrc[i].getAttribute("id"),
            A:lrc[i].getAttribute("artist"),
            T:lrc[i].getAttribute("title")
        };
    }
}

/////////////////////////////////////////////////////////////////////
/****************************QQ*************************************/
/////////////////////////////////////////////////////////////////////
function QQQueryString(artist, title){
	return Q_SERVER_URL+"name="+QQStringFilter(title)+"&singer="+QQStringFilter(artist)+"&from=qqplayer";
}

function QQRequestString(index,qr){
	return R_SERVER_URL+(qr[index].I - (Math.floor(qr[index].I/100)*100)).toString()+"/"+qr[index].I+".xml";
}

function QQQuery(artist, title) {
        try {
		xmlhttp.open("GET", QQQueryString(artist,title), false);
		xmlhttp.send();
        } catch (e) {
		$QQQueryResult = [];
		return;
        }
	if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) {
			var ret = A2U(xmlhttp.responseBody);
			AnalyzeQQXML(ret);
		} else {
			//et.CreateMessageBox(window.ID ,"Error","Unable to query.",0);
			fb.trace("TTLRX V3 result::" + (xmlhttp.responsetext || "HTTP error: " + xmlhttp.status));
		}
	}
}

function QQDownload(index) {
	xmlhttp.open("GET", QQRequestString(index,$QQQueryResult), false);
	xmlhttp.send();
    if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) {
			var l = A2U(xmlhttp.responseBody);
		    xmlDoc.loadXML(l);
			var lr = xmlDoc.getElementsByTagName("lyric");
			$LyricResult = lr[0].childNodes[0].text;
		} else {
			//et.CreateMessageBox(window.ID ,"Error","Unable to download.",0);
			fb.trace("TTLRX V3 result::" + (xmlhttp.responsetext || "HTTP error: " + xmlhttp.status));
		}
	}
}

function AnalyzeQQXML(str){
	xmlDoc.loadXML(str);
	$QQQueryResult = [];
	var lrc = xmlDoc.getElementsByTagName("songinfo");
	var name = xmlDoc.getElementsByTagName("name");
	var singer = xmlDoc.getElementsByTagName("singername");
	for(var i=0;i<lrc.length;i++){
        $QQQueryResult[i] = {
            I:lrc[i].getAttribute("id"),
            A:singer[i].childNodes[0].text,
            T:name[i].childNodes[0].text
        };
    }
}

/////////////////////////////////////////////////////////////////////
/*************************helpers***********************************/
/////////////////////////////////////////////////////////////////////

function QQStringFilter(s){
	s = s.toLowerCase();
	s = s.replace(/\'|·|\&|–/g,"");
	//trim all spaces
	s = s.replace(/(\s*)|(\s*$)/g,"");
	//truncate all symbols
	s = s.replace(/\(.*?\)|\[.*?]|{.*?}|（.*?/g, "");
	s = s.replace(/[-/:-@[-`{-~]+/g, "");
	s = et.Translate(s,0x0804,0x02000000);
	s = s.replace(/[\u2014\u2018\u201c\u2026\u3001\u3002\u300a\u300b\u300e\u300f\u3010\u3011\u30fb\uff01\uff08\uff09\uff0c\uff1a\uff1b\uff1f\uff5e\uffe5]+/g, "");
	//fb.trace(s);
    var ret = "";
    for(var i=0;i<s.length;i++){
        if(!(QQFilter.indexOf(s[i]))){
            ret += "+";
        }else if(QQFilter.indexOf(s[i].toUpperCase())<0){
			if(s.charCodeAt[i]<128){
				ret+="%"+s.charCodeAt[i].toString(16).toUpperCase();
			}else{
            var d = et.U2A(s[i]).toString(16);
            var p = "".concat("%"+d.substr(0,2)+"%"+d.substr(2,2)).toUpperCase();
            ret += p;
			}
		}else{
			ret += s[i];
		}
    }
	//fb.trace(ret);
	return ret;
}

function A2U(s){
	ado.Type = 1;
	ado.Open();
	ado.Write(s);
	ado.Position = 0;
	ado.Type = 2;
	ado.Charset = "gb2312";
	var ret = ado.ReadText();
	ado.Close();
	return ret;
}

function TTStringFilter(str){
	s = str;
	s = s.toLowerCase();
	s = s.replace(/\'|·|\$|\&|–/g,"");
	//trim all spaces
	s = s.replace(/(\s*)|(\s*$)/g,"");
	//truncate all symbols
	s = s.replace(/\(.*?\)|\[.*?]|{.*?}|（.*?/g, "");
	s = s.replace(/[-/:-@[-`{-~]+/g, "");
	s = et.Translate(s,0x0804,0x02000000);
	s = s.replace(/[\u2014\u2018\u201c\u2026\u3001\u3002\u300a\u300b\u300e\u300f\u3010\u3011\u30fb\uff01\uff08\uff09\uff0c\uff1a\uff1b\uff1f\uff5e\uffe5]+/g, ""); 
	//fb.trace(s);
	return s;
}

function toTTHexQueryString(data){
	var ret="",bit,lo,hi;
	for(var i=0;i<data.length;i++){
	bit = data.charCodeAt(i).toString(16);
	if(bit.length==2){
	    bit+="00";
	}else if(bit.length==4){
	    hi = bit.substr(0,2);
	    lo = bit.substr(2,2);
	    bit = lo+hi;
	}
	ret+=bit.toUpperCase();
	}
	return ret;
}

function toTTHexUTF8(data) {
    if (data == "" || data == null)return "";
    var buffer = "";
    
    for(var i=0; i<data.length; i++){
        var c = data.charCodeAt(i);
        var bs = [];
        if (c > 0x10000){
            // 4 bytes
            bs[0] = 0xF0 | ((c & 0x1C0000) >> 18);
            bs[1] = 0x80 | ((c & 0x3F000) >> 12);
            bs[2] = 0x80 | ((c & 0xFC0) >> 6);
            bs[3] = 0x80 | (c & 0x3F);
        }else if (c > 0x800){
            // 3 bytes
            bs[0] = 0xE0 | ((c & 0xF000) >> 12);
            bs[1] = 0x80 | ((c & 0xFC0) >> 6);
            bs[2] = 0x80 | (c & 0x3F);
        }else if (c > 0x80){
            // 2 bytes
            bs[0] = 0xC0 | ((c & 0x7C0) >> 6);
            bs[1] = 0x80 | (c & 0x3F);
        }else{
            // 1 byte
            bs[0] = c;
        }
        for(var j=0; j<bs.length; j++){
            var b = bs[j];
            var hex =((b & 0xF0) >> 4).toString(16) + (b & 0x0F).toString(16);
            buffer += hex.toUpperCase();
        }
    }
    return buffer;
}